%global qt5_version 5.15
# define to build docs. undefine if qt5-qttools is not available
%global docs 1

Summary: Qt5 - Qt IVI
Name:    qt5-qtivi
Version: 5.15.1
Release: 5%{?dist}

# See LGPL_EXCEPTIONS.txt, LICENSE.GPL3, respectively, for exception details
License: LGPLv2 with exceptions or GPLv3 with exceptions
Url:     http://www.qt.io
Source0: https://github.com/qt/qtivi/archive/v5.15.1_QtAS/qtivi-v5.15.1_QtAS.tar.gz
Patch0: qtivi-5.15.1-qface.patch
Patch1: qtivi-5.15.1-fix_default.patch

BuildRequires: make
BuildRequires: python3-qface
BuildRequires: python3-virtualenv
BuildRequires: taglib-devel
BuildRequires: qt5-qtbase-devel >= %{qt5_version}
BuildRequires: qt5-qtbase-private-devel >= %{qt5_version}
BuildRequires: qt5-qtdeclarative-devel >= %{qt5_version}
BuildRequires: qt5-qtremoteobjects-devel >= %{qt5_version}
BuildRequires: qt5-qtmultimedia-devel >= %{qt5_version}
BuildRequires: dlt-libs-devel
BuildRequires: gcc-c++

%description
The Qt In-Vehicle Infotainment (IVI) module provides both, the tools
and the core APIs, to implement Middleware APIs, Middleware
Backends, and Middlware Services. The Qt IVI Generator provides a
flexible way to define new APIs via an Interface Definition Language
(IDL) and generate classes for use, from C++ and QML.

%package genivi
Summary: Extra genivi support for %{name}
Requires: %{name}%{?_isa} = %{version}-%{release}
%description genivi
%{summary}.

%package devel
Summary: Development files for %{name}
Requires: %{name}%{?_isa} = %{version}-%{release}
Requires: %{name}-genivi%{?_isa} = %{version}-%{release}
Requires: qt5-qtbase-devel%{?_isa}
Requires: python3-qface
%description devel
%{summary}.

%package examples
Summary: Programming examples for %{name}
Requires: %{name}%{?_isa} = %{version}-%{release}
Requires: %{name}-genivi%{?_isa} = %{version}-%{release}
%description examples
%{summary}.

%package static
Summary: Static library files for %{name}
Requires: %{name}-devel%{?_isa} = %{version}-%{release}
Requires: %{name}%{?_isa} = %{version}-%{release}
%description static
%{summary}.

%if 0%{?docs}
%package doc
Summary: API documentation for %{name}
BuildArch: noarch
BuildRequires: qt5-qdoc
BuildRequires: qt5-qhelpgenerator
BuildRequires: qt5-qtbase-doc
Requires: qt5-qtbase-doc
%description doc
%{summary}.
%endif

%prep
%setup -q -n qtivi-%{version}_QtAS
%patch0 -p1
%patch1 -p1

%build

mkdir %{_target_platform}
pushd %{_target_platform}
%{qmake_qt5} .. "CONFIG += git_build -feature geniviextras"

%make_build

%if 0%{?docs}
%make_build docs
%endif

%install
make install INSTALL_ROOT=%{buildroot} -C %{_target_platform}

%if 0%{?docs}
make install_docs INSTALL_ROOT=%{buildroot} -C %{_target_platform}
%endif

%ldconfig_scriptlets

%files
%doc README.md
%license LICENSE.*
%{_qt5_libdir}/libQt5IviCore.so.*
%{_qt5_libdir}/libQt5IviMedia.so.*
%{_qt5_libdir}/libQt5IviVehicleFunctions.so.*
%{_qt5_plugindir}/qtivi
%{_qt5_qmldir}/QtIvi
%{_qt5_bindir}/ivimedia-simulation-server
%{_qt5_bindir}/ivivehiclefunctions-simulation-server

%files genivi
%{_qt5_libdir}/libQt5GeniviExtras.so.*

%files devel
%{_qt5_headerdir}/QtIviCore/
%{_qt5_headerdir}/QtIviMedia/
%{_qt5_headerdir}/QtIviRemoteObjectsHelper/
%{_qt5_headerdir}/QtIviVehicleFunctions/
%{_qt5_headerdir}/QtGeniviExtras/
%exclude %{_libdir}/libQt5GeniviExtras.la
%exclude %{_qt5_libdir}/libQt5IviCore.la
%exclude %{_qt5_libdir}/libQt5IviMedia.la
%exclude %{_qt5_libdir}/libQt5IviRemoteObjectsHelper.la
%exclude %{_qt5_libdir}/libQt5IviVehicleFunctions.la
%{_qt5_libdir}/cmake/Qt5GeniviExtras/
%{_qt5_libdir}/cmake/Qt5IviCore/
%{_qt5_libdir}/cmake/Qt5IviMedia/
%{_qt5_libdir}/cmake/Qt5IviRemoteObjectsHelper/
%{_qt5_libdir}/cmake/Qt5IviVehicleFunctions/
%{_qt5_libdir}/libQt5GeniviExtras.so
%{_qt5_libdir}/libQt5IviCore.so
%{_qt5_libdir}/libQt5IviMedia.so
%{_qt5_libdir}/libQt5IviVehicleFunctions.so
%{_qt5_libdir}/pkgconfig/Qt5GeniviExtras.pc
%{_qt5_libdir}/pkgconfig/Qt5IviCore.pc
%{_qt5_libdir}/pkgconfig/Qt5IviMedia.pc
%{_qt5_libdir}/pkgconfig/Qt5IviVehicleFunctions.pc
%{_qt5_bindir}/ivigenerator
%{_qt5_archdatadir}/mkspecs/features/*
%{_qt5_archdatadir}/mkspecs/modules/*

%files static
%{_qt5_libdir}/libQt5Ivi*.a
%{_qt5_libdir}/libQt5Ivi*.prl
%{_qt5_libdir}/libQt5Genivi*.prl

%files examples
%{_qt5_examplesdir}/ivicore
%{_qt5_examplesdir}/ivimedia
%{_qt5_examplesdir}/ivivehiclefunctions
%{_qt5_examplesdir}/geniviextras

%if 0%{?docs}
%files doc
%{_qt5_docdir}/*
%endif


%changelog
* Thu Jan  6 2022 Stephen Smoogen <smooge@fedoraproject.org> - 5.15.1-5
- Make qface changes for F35
- Fix generate.py for F35/Python3.10

* Tue Dec 14 2021 Stephen Smoogen <smooge@fedoraproject.org> - 5.15.1-4
- Increase verbosity of description using text from website.

* Wed Jun  9 2021  <alex@rhel84-2> - 5.15.1-3
- Add qt5-qtivi-genivi subpackage

* Fri Apr 30 2021 Alexander Larsson <alexl@redhat.com> - 5.15.1-2
- Add python3-qface dependency to -devel package

* Thu Apr 29 2021 Alexander Larsson <alexl@redhat.com> - 5.15.1-1
- Initial version
